
#property copyright "Copyright  2011, Plamen Petkov"
#property link      "plamendp [ a t ] gmail.com"

#property indicator_separate_window
#property indicator_levelcolor C'0x30,0x30,0x30'
#property indicator_buffers 7
#property indicator_color1 CLR_NONE
#property indicator_color2 CLR_NONE
#property indicator_color3 CLR_NONE
#property indicator_color4 CLR_NONE
#property indicator_color5 Green
#property indicator_width5 2
#property indicator_color6 Red
#property indicator_width6 2
#property indicator_color7 Gray
#property indicator_width1 2
#property indicator_level1 32.0
#property indicator_width2 2
#property indicator_level2 50.0
#property indicator_width3 2
#property indicator_level3 68.0
extern int TimeFrame = 0;
extern string CurrencyPair = "Current Symbol";
extern string mll = "-=-=-=-=-=-=-=-=-=-=-=-=-=-=-";
extern string mlll = "TDI/RSI Parameters.";
extern string mllll = "Do not change!";
extern int RSIPeriod = 13;
extern int RSIPrice = 0;
extern int VolatilityBand = 34;
extern int RSIPriceLine = 2;
extern int RSIPriceType = 0;
extern int TradeSignalLine = 7;
extern int TradeSignalType = 0;
extern string zll = "-=-=-=-=-=-=-=-=-=-=-=-=-=-=-";
extern bool showSlopeValue = TRUE;
extern bool showBounceValue = TRUE;
extern string flll = ":: false=Freezes last bar till its end.";
extern bool RefreshLastBar = TRUE;
extern string zllll = ":: Alert settings (log file in experts/files)";
extern bool EnableAlerts = TRUE;
extern bool BounceAlerts = TRUE;
extern bool PopupAlerts = TRUE;
extern bool EmailAlerts = TRUE;
extern bool PushAlerts = TRUE;
extern bool HACandleInfo = TRUE;
extern bool LogAlerts = TRUE;
extern string LogFileName = "tmswatchdog";
extern string blllllll = "Bounce = Current Slope - Previous Slope";
extern string blll = ":: No Cross alerts if Slope is bellow this number";
extern double slopeThreshold = 4.5;
extern string bllll = ":: No Bounce alerts if Bounce is bellow this number";
extern double bounceThreshold = 3.0;
extern string blllll = ":: No Bounce alerts if Slope is bellow this number";
extern double bounceMinSlope = 3.0;
extern string bllllll = ":: No Bounce alerts if Green and Red are farther";
extern double bounceMaxDistance = 2.5;
extern string flllll = ":: Show label with Symbol and TF if differ from current chart";
extern bool showSymbolAndTF = TRUE;
extern bool ColorizeLastBar = TRUE;
extern string zlllk = ":: Heiken Ashi (Synergy) stuff";
extern string SynergyIndiFileName = "Synergy_APB";
extern bool showHeikenAshiInfo = TRUE;
extern string zlll = ":: Define some colors and other fancy stuff";
extern color LastBarColor = Green;
extern int LastBarWidth = 2;
extern color InfoColorUp = Aqua;
extern color InfoColorDown = Red;
extern string InfoFontName = "Arial";
extern int InfoFontSize = 9;
extern int InfoCorner = 3;
extern int InfoXShift = 5;
extern int InfoYShift = 15;
extern color symbolInfoColor = Yellow;
extern string symbolInfoFontName = "Arial";
extern int symbolInfoFontSize = 9;
int gi380 = 2;
int gi384 = 3;
int gi388 = 0;
int gi392 = 1;
string gs396 = "";
double gibuf404[];
double gibuf408[];
double gibuf412[];
double gibuf416[];
double gibuf420[];
double gibuf424[];
double gibuf428[];
string gs432;
string gname440;
string gname448;
string gname456;
string gname464;
string gname472;
string gname480;
string gname488;
string gname496;
string gname504;
string gname512;
string gname520;
int gi528 = 1;
string gsa532[] = {"AUDCAD", "AUDCHF", "AUDJPY", "AUDNZD", "AUDUSD", "CADCHF", "CADJPY", "CHFJPY", "CHFNOK", "CHFSEK", "EURAUD", "EURCAD", "EURCHF", "EURCZK", "EURDKK", "EURGBP", "EURHUF", "EURJPY", "EURNOK", "EURNZD", "EURSEK", "EURTRY", "EURUSD", "GBPAUD", "GBPCAD", "GBPCHF", "GBPJPY", "GBPNZD", "GBPSEK", "GBPUSD", "HDKJPY", "NOKJPY", "NZDCAD", "NZDCHF", "NZDJPY", "NZDUSD", "SEKJPY", "SGDJPY", "TRYJPY", "USDCAD", "USDCHF", "USDCZK", "USDDKK", "USDHKD", "USDHUF", "USDJPY", "USDMXN", "USDNOK", "USDRUB", "USDSEK", "USDSGD", "USDTRY", "USDZAR", "ZARJPY", "SPX500-eur"};
string gsa536[] = {"M1", "M5", "M15", "M30", "H1", "H4", "D1", "W1", "MN"};
int gia540[] = {1, 5, 15, 30, 60, 240, 1440, 10080, 43200};
string gsa544[50][50];
int gia548[50][50];

int init() {
   if (TimeFrame == 0) TimeFrame = Period();
   if (CurrencyPair == "Current Symbol") CurrencyPair = Symbol();
   gs432 = "TMSWatchDog-" + CurrencyPair + "(" + TimeFrame + ")";
   gname440 = gs432 + "lastBar";
   gname448 = gs432 + "slope0";
   gname456 = gs432 + "slope1";
   gname464 = gs432 + "slopesScale";
   gname472 = gs432 + "X0";
   gname480 = gs432 + "X1";
   gname488 = gs432 + "Bounce0";
   gname496 = gs432 + "Bounce1";
   gname504 = gs432 + "Pair";
   gname512 = gs432 + "TFrame";
   gname520 = gs432 + "HAInfo";
   deleteMyObjects();
   LogFileName = LogFileName + "-" + TimeToStr(TimeLocal(), TIME_DATE) + ".log";
   IndicatorShortName(gs432);
   SetIndexBuffer(0, gibuf404);
   SetIndexBuffer(1, gibuf420);
   SetIndexBuffer(2, gibuf424);
   SetIndexBuffer(3, gibuf428);
   SetIndexBuffer(4, gibuf408);
   SetIndexBuffer(5, gibuf412);
   SetIndexBuffer(6, gibuf416);
   SetIndexStyle(0, DRAW_NONE);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexStyle(3, DRAW_LINE);
   SetIndexStyle(4, DRAW_LINE);
   SetIndexStyle(5, DRAW_LINE);
   SetIndexStyle(6, DRAW_HISTOGRAM);
   SetIndexLabel(0, NULL);
   SetIndexLabel(1, "Up Zone");
   SetIndexLabel(2, "Md Zone");
   SetIndexLabel(3, "Dn Zone");
   SetIndexLabel(4, "RSI Price Line");
   SetIndexLabel(5, "Trade Signal Line");
   SetIndexLabel(6, "Slopes");
   return (0);
}

int deinit() {
   deleteMyObjects();
   return (0);
}

int start() {
   int li28;
   int li32;
   color lcolor36;
   color lcolor40;
   color lcolor44;
   color lcolor48;
   string ltext52;
   string ltext60;
   double ld72;
   double ld80;
   double ld88;
   double ld184;
   double lda192[];
   int li0 = 0;
   int li68 = 0;
   string ls96 = "";
   ArrayResize(lda192, VolatilityBand);
   deleteMyObjects();
   if (showSymbolAndTF && CurrencyPair != Symbol() || TimeFrame != Period()) {
      if (ObjectFind(gname504) == -1) ObjectCreate(gname504, OBJ_LABEL, WindowFind(gs432), 0, 0);
      ObjectSet(gname504, OBJPROP_CORNER, 1);
      ObjectSet(gname504, OBJPROP_XDISTANCE, 5);
      ObjectSet(gname504, OBJPROP_YDISTANCE, 5);
      ObjectSetText(gname504, CurrencyPair + " (" + timeFrameToString(TimeFrame) + ")", symbolInfoFontSize, symbolInfoFontName, symbolInfoColor);
   }
   int lindcounted196 = IndicatorCounted();
   int li200 = Bars - lindcounted196 - 1;
   if (RefreshLastBar) li68 = 0;
   else li68 = 1;
   for (int li204 = li200; li204 >= li0; li204--) {
      gibuf404[li204] = iRSI(CurrencyPair, TimeFrame, RSIPeriod, RSIPrice, li204);
      ld184 = 0;
      for (int li208 = li204; li208 < li204 + VolatilityBand; li208++) {
         lda192[li208 - li204] = gibuf404[li208];
         ld184 += gibuf404[li208] / VolatilityBand;
      }
      gibuf420[li204] = ld184 + 1.6185 * StDev(lda192, VolatilityBand);
      gibuf428[li204] = ld184 - 1.6185 * StDev(lda192, VolatilityBand);
      gibuf424[li204] = (gibuf420[li204] + gibuf428[li204]) / 2.0;
   }
   for (li204 = li200 - li68; li204 >= li0; li204--) {
      gibuf408[li204] = iMAOnArray(gibuf404, 0, RSIPriceLine, 0, RSIPriceType, li204);
      gibuf412[li204] = iMAOnArray(gibuf404, 0, TradeSignalLine, 0, TradeSignalType, li204);
   }
   if (ColorizeLastBar) {
      if (ObjectFind(gname440) == -1) ObjectCreate(gname440, OBJ_TREND, WindowFind(gs432), Time[li0], gibuf408[li0], Time[li0 + 1], gibuf408[li0 + 1]);
      ObjectSet(gname440, OBJPROP_RAY, FALSE);
      ObjectSet(gname440, OBJPROP_COLOR, LastBarColor);
      ObjectSet(gname440, OBJPROP_WIDTH, LastBarWidth);
   }
   double ld112 = gibuf408[li0];
   double ld120 = gibuf408[li0 + 1];
   double ld128 = gibuf408[li0 + 2];
   double ld136 = gibuf408[li0 + 3];
   double ld144 = gibuf412[li0];
   double ld152 = gibuf412[li0 + 1];
   double ld160 = gibuf412[li0 + 2];
   double ldunused168 = gibuf412[li0 + 3];
   double ld4 = ld112 - ld120;
   double ld12 = ld120 - ld128;
   double ld20 = ld128 - ld136;
   ld4 = NormalizeDouble(ld4, 1);
   ld12 = NormalizeDouble(ld12, 1);
   ld20 = NormalizeDouble(ld20, 1);
   if (showSlopeValue) {
      li28 = CrossOver(gibuf408[li0], gibuf408[li0 + 1], gibuf412[li0], gibuf412[li0 + 1]);
      li32 = CrossOver(gibuf408[li0 + 1], gibuf408[li0 + 2], gibuf412[li0 + 1], gibuf412[li0 + 2]);
      lcolor36 = InfoColorDown;
      lcolor40 = InfoColorDown;
      if (ld4 >= 0.0) lcolor36 = InfoColorUp;
      if (ld12 >= 0.0) lcolor40 = InfoColorUp;
      ltext52 = "Cur. Slope: " + DoubleToStr(MathAbs(ld4), gi528);
      ltext60 = "Prev. Slope: " + DoubleToStr(MathAbs(ld12), gi528);
      if (li28 != 0) ltext52 = ltext52 + " [cross]";
      if (li32 != 0) ltext60 = ltext60 + " [cross]";
      if (ObjectFind(gname456) == -1) ObjectCreate(gname456, OBJ_LABEL, WindowFind(gs432), 0, 0);
      ObjectSet(gname456, OBJPROP_CORNER, InfoCorner);
      ObjectSet(gname456, OBJPROP_XDISTANCE, InfoXShift + 5);
      ObjectSet(gname456, OBJPROP_YDISTANCE, InfoYShift + 5);
      ObjectSetText(gname456, ltext60, InfoFontSize, InfoFontName, lcolor40);
      if (ObjectFind(gname448) == -1) ObjectCreate(gname448, OBJ_LABEL, WindowFind(gs432), 0, 0);
      ObjectSet(gname448, OBJPROP_CORNER, InfoCorner);
      ObjectSet(gname448, OBJPROP_XDISTANCE, InfoXShift + 5);
      ObjectSet(gname448, OBJPROP_YDISTANCE, InfoYShift + 25);
      ObjectSetText(gname448, ltext52, InfoFontSize, InfoFontName, lcolor36);
   }
   if (HACandleInfo || showHeikenAshiInfo) getHeikenAshiCandle(ld72, ld80, ld88);
   if (showHeikenAshiInfo) {
      if (ld72 >= 0.0) lcolor44 = InfoColorUp;
      else lcolor44 = InfoColorDown;
      if (ObjectFind(gname520) == -1) ObjectCreate(gname520, OBJ_LABEL, WindowFind(gs432), 0, 0);
      ObjectSet(gname520, OBJPROP_CORNER, InfoCorner);
      ObjectSet(gname520, OBJPROP_XDISTANCE, InfoXShift + 5);
      ObjectSet(gname520, OBJPROP_YDISTANCE, InfoYShift + 45);
      ObjectSetText(gname520, "Current HA: " + DoubleToStr(MathAbs(ld72), 0) + "/" + DoubleToStr(ld80, 0) + "/" + DoubleToStr(ld88, 0), InfoFontSize, InfoFontName, lcolor44);
   }
   if (HACandleInfo) ls96 = ", HA Candle: " + DoubleToStr(ld72, 0) + "/" + DoubleToStr(ld80, 0) + "/" + DoubleToStr(ld88, 0);
   double ld104 = ld4 - ld12;
   int lbool176 = ld112 > ld144 && ld120 > ld152 && ld128 > ld160;
   int lbool180 = ld112 < ld144 && ld120 < ld152 && ld128 < ld160;
   if (showBounceValue && (lbool176 && ld104 > 0.0) || (lbool180 && ld104 < 0.0)) {
      if (ld104 > 0.0) lcolor48 = InfoColorUp;
      else lcolor48 = InfoColorDown;
      if (ObjectFind(gname488) == -1) ObjectCreate(gname488, OBJ_LABEL, WindowFind(gs432), 0, 0);
      ObjectSet(gname488, OBJPROP_CORNER, InfoCorner);
      ObjectSet(gname488, OBJPROP_XDISTANCE, InfoXShift + 5);
      ObjectSet(gname488, OBJPROP_YDISTANCE, InfoYShift + 65);
      ObjectSetText(gname488, "Bounce: " + DoubleToStr(MathAbs(ld104), 1), InfoFontSize, InfoFontName, lcolor48);
   }
   if (li28 == -1 && MathAbs(ld4) > slopeThreshold) fireAlert("Cross DN,", " Slope: " + DoubleToStr(ld4, 1) + ls96, gs396, CurrencyPair, TimeFrame);
   if (li28 == 1 && MathAbs(ld4) > slopeThreshold) fireAlert("Cross UP,", " Slope: " + DoubleToStr(ld4, 1) + ls96, gs396, CurrencyPair, TimeFrame);
   if (ld104 > bounceThreshold && MathAbs(ld4) > bounceMinSlope && MathAbs(ld120 - ld152) < bounceMaxDistance && lbool176 && BounceAlerts) fireAlert("Bounce UP,", " B: " + DoubleToStr(ld104, 1) + ", Slope: " + DoubleToStr(ld4, 1) + ls96, gs396, CurrencyPair, TimeFrame);
   if (ld104 < (-bounceThreshold) && MathAbs(ld4) > bounceMinSlope && MathAbs(ld120 - ld152) < bounceMaxDistance && lbool180 && BounceAlerts) fireAlert("Bounce DN,", " B: " + DoubleToStr(ld104, 1) + ", Slope: " + DoubleToStr(ld4, 1) + ls96, gs396, CurrencyPair, TimeFrame);
   return (0);
}

void deleteMyObjects() {
   if (ObjectFind(gname440) != -1) ObjectDelete(gname440);
   if (ObjectFind(gname448) != -1) ObjectDelete(gname448);
   if (ObjectFind(gname456) != -1) ObjectDelete(gname456);
   if (ObjectFind(gname464) != -1) ObjectDelete(gname464);
   if (ObjectFind(gname472) != -1) ObjectDelete(gname472);
   if (ObjectFind(gname480) != -1) ObjectDelete(gname480);
   if (ObjectFind(gname488) != -1) ObjectDelete(gname488);
   if (ObjectFind(gname496) != -1) ObjectDelete(gname496);
   if (ObjectFind(gname504) != -1) ObjectDelete(gname504);
   if (ObjectFind(gname512) != -1) ObjectDelete(gname512);
   if (ObjectFind(gname520) != -1) ObjectDelete(gname520);
}

int CrossOver(double ad0, double ad8, double ad16, double ad24) {
   if (ad8 > ad24 && ad0 < ad16) return (-1);
   if (ad8 < ad24 && ad0 > ad16) return (1);
   return (0);
}

void fireAlert(string as0, string as8, string as16, string asymbol24, int atimeframe32) {
   int li52;
   int li56;
   int li60;
   string ls36 = "";
   int liunused44 = 0;
   int liunused48 = 0;
   if (EnableAlerts) {
      if (as16 == "") as16 = "TDISLOPE";
      li60 = 0;
      li52 = symbolToIndex(asymbol24);
      li56 = timeFrameToIndex(atimeframe32);
      if (li52 < 0 || li56 < 0) Print("Error finding a symbol or period: Symbol=" + asymbol24 + " Period=" + atimeframe32);
      if (gsa544[li52][li56] != as0 || gia548[li52][li56] != iTime(asymbol24, atimeframe32, li60)) {
         ls36 = "[" + as16 + "], " + asymbol24 + ", " + timeFrameToString(atimeframe32) + ", " + as0 + as8;
         if (PopupAlerts) Alert(ls36);
         if (EmailAlerts) SendMail(TimeToStr(TimeLocal(), TIME_DATE|TIME_SECONDS) + "  " + ls36, TimeToStr(TimeLocal(), TIME_DATE|TIME_SECONDS) + "  " + ls36);
         if (PushAlerts) SendNotification( /*TimeToStr(TimeLocal(), TIME_DATE|TIME_SECONDS)*/ls36 +"@"+ Bid );
         if (LogAlerts) logMessage(LogFileName, ls36);
         gsa544[li52][li56] = as0;
         gia548[li52][li56] = iTime(asymbol24, atimeframe32, li60);
      }
   }
}

int symbolToIndex(string as0) {
   for (int lindex8 = 0; lindex8 < ArraySize(gsa532); lindex8++)
      if (as0 == gsa532[lindex8]) return (lindex8);
   return (-1);
}

string timeFrameToString(int ai0) {
   for (int li4 = ArraySize(gia540) - 1; li4 >= 0; li4--)
      if (ai0 == gia540[li4]) return (gsa536[li4]);
   return ("");
}

int timeFrameToIndex(int ai0) {
   for (int liret4 = ArraySize(gia540) - 1; liret4 >= 0; liret4--)
      if (ai0 == gia540[liret4]) return (liret4);
   return (-1);
}

int logMessage(string aname0, string as8) {
   int lfile16 = FileOpen(aname0, FILE_WRITE|FILE_READ);
   if (lfile16 < 1) lfile16 = FileOpen(aname0, FILE_WRITE);
   if (lfile16 < 1) {
      Print("Unable to open/create file " + aname0);
      return (0);
   }
   int ldatetime20 = TimeLocal();
   FileSeek(lfile16, 0, SEEK_END);
   FileWrite(lfile16, TimeToStr(ldatetime20, TIME_DATE|TIME_SECONDS) + "  " + as8);
   FileClose(lfile16);
   return (1);
}

void getHeikenAshiCandle(double &ad0, double &ad8, double &ad16) {
   double licustom40;
   double licustom48;
   double licustom24 = iCustom(CurrencyPair, TimeFrame, SynergyIndiFileName, gi380, 0);
   double licustom32 = iCustom(CurrencyPair, TimeFrame, SynergyIndiFileName, gi384, 0);
   double licustom56 = iCustom(CurrencyPair, TimeFrame, SynergyIndiFileName, gi388, 0);
   double licustom64 = iCustom(CurrencyPair, TimeFrame, SynergyIndiFileName, gi392, 0);
   ad0 = licustom32 - licustom24;
   if (ad0 > 0.0) {
      licustom40 = licustom64;
      licustom48 = licustom56;
   } else {
      licustom40 = licustom56;
      licustom48 = licustom64;
   }
   ad8 = licustom40 - MathMax(licustom24, licustom32);
   ad16 = MathMin(licustom24, licustom32) - licustom48;
   if (ad0 != 0.0) ad0 = ad0 / MarketInfo(CurrencyPair, MODE_POINT) / 10.0;
   if (ad8 != 0.0) ad8 = ad8 / MarketInfo(CurrencyPair, MODE_POINT) / 10.0;
   if (ad16 != 0.0) ad16 = ad16 / MarketInfo(CurrencyPair, MODE_POINT) / 10.0;
}

double StDev(double ada0[], int ai4) {
   return (MathSqrt(Variance(ada0, ai4)));
}

double Variance(double ada0[], int ai4) {
   double ld8;
   double ld16;
   for (int lindex24 = 0; lindex24 < ai4; lindex24++) {
      ld8 += ada0[lindex24];
      ld16 += MathPow(ada0[lindex24], 2);
   }
   return ((ld16 * ai4 - ld8 * ld8) / (ai4 * (ai4 - 1)));
}

